import jj2000.j2k.wavelet.analysis.AnWTFilterFloatHaar;
import jj2000.j2k.wavelet.analysis.AnWTParamFilterFloatHaar;
import jj2000.j2k.wavelet.synthesis.SynWTFilterFloatHaar;
import jj2000.j2k.wavelet.synthesis.SynWTParamFilterFloatHaar;

/*
 * Created on Mar 21, 2006
 *
 */

public class TestHaar {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		AnWTParamFilterFloatHaar haar_an = new AnWTParamFilterFloatHaar(1);
		SynWTParamFilterFloatHaar haar_syn = new SynWTParamFilterFloatHaar(1);
		
		//AnWTFilterFloatHaar haar_an = new AnWTFilterFloatHaar();
		//SynWTFilterFloatHaar haar_syn = new SynWTFilterFloatHaar();
		
		//void analyze_lpf(float inSig[], int inOff, int inLen, int inStep, 
        //float lowSig[], int lowOff, int lowStep,
        //float highSig[], int highOff, int highStep) 

		float inSig[] = {1, 2, 3, 4, 5, 6, 7, 8};
		float lowSig[] = {0, 0, 0, 0};
		float highSig[] = {0, 0, 0, 0};
		
		System.out.println("Analysis, Filter: " + haar_an.toString());
		haar_an.analyze_lpf(inSig, 0, inSig.length, 1, 
				lowSig, 0, 1, 
				highSig, 0, 1 );
		
		System.out.print("in:   ");
		for (int i = 0; i < inSig.length; i++)
		{
			System.out.print  (inSig[i] + ", ");
		}
		System.out.println ();
		
		System.out.print("outL: ");
		for (int i = 0; i < lowSig.length; i++)
		{
			System.out.print  (lowSig[i] + ", ");
		}
		System.out.println ();
		
		System.out.print("outH: ");
		for (int i = 0; i < highSig.length; i++)
		{
			System.out.print  (highSig[i] + ", ");
		}
		System.out.println ();
		
		System.out.println("Synthesis, Filter: " + haar_syn.toString());
		float recSig [] = { 0, 0, 0, 0, 0, 0, 0, 0 };
		
		haar_syn.synthetize_lpf(lowSig, 0, 4, 1, highSig, 0, 4, 1, recSig, 0, 1);
		System.out.print("Rec:  ");
		for (int i = 0; i < recSig.length; i++)
		{
			System.out.print  (recSig[i] + ", ");
		}
		System.out.println ();
		
	}

}
