import java.io.IOException;

import jj2000.j2k.image.DataBlkInt;
import jj2000.j2k.image.ImageStatsCalculator;
import jj2000.j2k.image.edgedectection.Sobel;
import jj2000.j2k.image.input.ImgReaderPGM;

/*
 * Created on Jun 2, 2006
 *
 */

public class EdgeDetection {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String fname = args[0];
		System.out.println("Calculating edge image of " + fname );
    	try
		{
    		Sobel sobel = new Sobel();
    		ImgReaderPGM reader = new ImgReaderPGM(fname);
    		DataBlkInt blk =  ImageStatsCalculator.getDataBlkInt(reader,0);
    		//System.out.println (sobel.imageAngle(blk, 80));
    		ImageStatsCalculator.writePGM(sobel.edgeImage(blk, 130), "edge.pgm", 0);
    		
		}
    	catch (IOException e)
		{
    		System.out.println("ERROR");
		}


	}

}
